@echo off

:: ========================================== SET ENVIRONMENT, CHOOSE THE ACTION

if "%OS%" == "Windows_NT" setlocal

if "%OS%" == "Windows_NT" (
  set "DIRNAME=%~dp0%"
) else (
  set DIRNAME=.\
)

pushd %DIRNAME%..
if "x%LS_HOME%" == "x" (
  set "LS_HOME=%CD%"
)
popd

set "EXECUTABLE=%LS_HOME%\bin\service\ls_service.exe"

if not "%ProgramFiles(x86)%x" == "x" (
  set "EXECUTABLE=%LS_HOME%\bin\service\ls_service64.exe"
)

set SERVICE_NAME=license-server
set PR_DISPLAYNAME=License Server
set PR_DESCRIPTION=JRebel License Server (http://jrebel.com)


if ""%1"" == ""install"" goto doInstall
if ""%1"" == ""uninstall"" goto doUninstall
if ""%1"" == ""start"" goto doStart
if ""%1"" == ""stop"" goto doStop


echo Usage:  service commands ( options ... )
echo commands:
echo   install               Install License Server as a service
echo   uninstall             Uninstall License Server service
echo   start                 Start License Server service
echo   stop                  Stop License Server service
goto end




:: ========================================== ACTIONS

:doStart
  echo Starting service %SERVICE_NAME%
  sc start %SERVICE_NAME% 2>&1 >NUL
  if %errorlevel% neq 0 (
    set errorcode=%errorlevel%
    echo Was unable to start %SERVICE_NAME%
  ) else (
    echo Service successfully started
  )
  goto end


:doStop
  echo Stopping service %SERVICE_NAME%
  sc stop %SERVICE_NAME% 2>&1 >NUL
  if %errorlevel% neq 0 (
    set errorcode=%errorlevel%
    echo Was unable to stop %SERVICE_NAME%
  ) else (
    echo Service stopped
  )
  goto end


:doUninstall
  "%EXECUTABLE%" //DS//%SERVICE_NAME%
  set errorcode=%errorlevel%
  if not errorlevel 1 goto removed
  echo Failed removing '%SERVICE_NAME%' service
  goto end
  :removed
  echo The service '%SERVICE_NAME%' has been removed
  goto end


:doInstall
  shift
  echo Installing the service '%SERVICE_NAME%' ...
  echo Using JAVA_HOME:        "%JAVA_HOME%"

  set "PR_INSTALL=%EXECUTABLE%"
  set "PR_LOGPATH=%LS_HOME%\logs"
  set "PR_CLASSPATH=%LS_HOME%\lib\license-server.jar"
  set PR_STDOUTPUT=auto
  set PR_STDERROR=auto
  
  :setArgs
    if ""%1""=="""" goto doneSetArgs
    set JVM_OPTS=%JVM_OPTS% ++JvmOptions=%1
    shift
    goto setArgs
  :doneSetArgs

  set OPTS=--StartClass com.zeroturnaround.ls.ServiceStartup
  set OPTS=%OPTS% --StopClass com.zeroturnaround.ls.Shutdown
  set OPTS=%OPTS% --StartPath "%LS_HOME%" --Startup auto
  set OPTS=%OPTS% --StopParams stop
  set OPTS=%OPTS% --StartMode Java --StopMode Java

  "%EXECUTABLE%" //IS//%SERVICE_NAME% %OPTS% %JVM_OPTS%

  if ERRORLEVEL 1 (
    echo Installation failed for '%SERVICE_NAME%' service. Make sure you have Administrator privileges to install the Windows service. See %LS_HOME%\logs for additional information.
    goto end
  )

  echo The service '%SERVICE_NAME%' has been installed.


:end
